//############################################################################
//
// File Name	: 'global.h'
// Title		: AVR project global include 
//                         
// Author		: Zoltan Gradwohl
// Created		: 03/10/2008
// Revised		: 03/10/2008
// Version		: 1.0
// Target MCU	: Atmel AVR series
// Editor Tabs	: 4
//
//
//
//
//############################################################################


#ifndef GLOBAL_H
#define GLOBAL_H

#ifndef WIN32
	// true/false defines
	#define FALSE	0
	#define TRUE	-1
#endif

// MIN/MAX/ABS macros
#define MIN(a,b)	((a<b)?(a):(b))
#define MAX(a,b)	((a>b)?(a):(b))
#define ABS(x)		((x>0)?(x):(-x))

#define IN(x) 		(*(&x - 2))  			// address of input register of port x  
#define DDR(x) 		(*(&x - 1))  			// address of data direction register of port x         
#define OUT(x) 		(*(&x ))  				// address of output register of port x    
#define ABS(x)      ((x>0)?(x):(-x)) 


#define ASCII_ESC  0x1B 
#define ASCII_CR   0x0D 


// constants
#define PI		3.14159265359

#ifndef F_CPU
// CPU clock speed
//#define F_CPU        16000000L               		// 16MHz processor
//#define F_CPU        14745000L               		// 14.745MHz processor
#define F_CPU        11059200L               		// 11.059MHz processor
//#define F_CPU        8000000L               		// 8MHz processor
//#define F_CPU        7372800L               		// 7.37MHz processor
//#define F_CPU        4000000L               		// 4MHz processor
//#define F_CPU        3686400L               		// 3.69MHz processor
#endif

#define CYCLES_PER_US ((F_CPU+500000L)/1000000L) 		// cpu cycles per microsecond

//#define DEBUG_HAL815

#endif
